# coding: utf-8

"""
    Magneto API

    Magneto API is the RESTful API for the Rely.io platform.

    The version of the OpenAPI document: v0.0.1
    Contact: contact@rely.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from magneto_api_client.models.blueprint_options import BlueprintOptions
from magneto_api_client.models.blueprint_relation import BlueprintRelation
from magneto_api_client.models.calculation_property import CalculationProperty
from magneto_api_client.models.reference_property import ReferenceProperty
from magneto_api_client.models.schema_properties import SchemaProperties
from typing import Optional, Set
from typing_extensions import Self

class BlueprintRead(BaseModel):
    """
    Base class for models that have audit columns.
    """ # noqa: E501
    id: Annotated[str, Field(strict=True)]
    title: Annotated[str, Field(min_length=1, strict=True)]
    description: Optional[StrictStr] = None
    icon: Optional[StrictStr] = None
    schema_properties: Optional[SchemaProperties] = Field(default=None, alias="schemaProperties")
    reference_properties: Optional[Dict[str, ReferenceProperty]] = Field(default=None, alias="referenceProperties")
    calculation_properties: Optional[Dict[str, CalculationProperty]] = Field(default=None, alias="calculationProperties")
    relations: Optional[Dict[str, BlueprintRelation]] = None
    options: Optional[BlueprintOptions] = None
    is_active: Optional[StrictBool] = Field(default=True, alias="isActive")
    is_hideable: Optional[StrictBool] = Field(default=True, alias="isHideable")
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    created_by: Optional[StrictInt] = Field(default=None, alias="createdBy")
    updated_at: Optional[datetime] = Field(default=None, alias="updatedAt")
    updated_by: Optional[StrictInt] = Field(default=None, alias="updatedBy")
    user_editable: StrictBool = Field(alias="userEditable")
    user_deletable: StrictBool = Field(alias="userDeletable")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["id", "title", "description", "icon", "schemaProperties", "referenceProperties", "calculationProperties", "relations", "options", "isActive", "isHideable", "createdAt", "createdBy", "updatedAt", "updatedBy", "userEditable", "userDeletable"]

    @field_validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^([a-z0-9_.-]+)$", value):
            raise ValueError(r"must validate the regular expression /^([a-z0-9_.-]+)$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BlueprintRead from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of schema_properties
        if self.schema_properties:
            _dict['schemaProperties'] = self.schema_properties.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each value in reference_properties (dict)
        _field_dict = {}
        if self.reference_properties:
            for _key_reference_properties in self.reference_properties:
                if self.reference_properties[_key_reference_properties]:
                    _field_dict[_key_reference_properties] = self.reference_properties[_key_reference_properties].to_dict()
            _dict['referenceProperties'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each value in calculation_properties (dict)
        _field_dict = {}
        if self.calculation_properties:
            for _key_calculation_properties in self.calculation_properties:
                if self.calculation_properties[_key_calculation_properties]:
                    _field_dict[_key_calculation_properties] = self.calculation_properties[_key_calculation_properties].to_dict()
            _dict['calculationProperties'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each value in relations (dict)
        _field_dict = {}
        if self.relations:
            for _key_relations in self.relations:
                if self.relations[_key_relations]:
                    _field_dict[_key_relations] = self.relations[_key_relations].to_dict()
            _dict['relations'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of options
        if self.options:
            _dict['options'] = self.options.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BlueprintRead from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "title": obj.get("title"),
            "description": obj.get("description"),
            "icon": obj.get("icon"),
            "schemaProperties": SchemaProperties.from_dict(obj["schemaProperties"]) if obj.get("schemaProperties") is not None else None,
            "referenceProperties": dict(
                (_k, ReferenceProperty.from_dict(_v))
                for _k, _v in obj["referenceProperties"].items()
            )
            if obj.get("referenceProperties") is not None
            else None,
            "calculationProperties": dict(
                (_k, CalculationProperty.from_dict(_v))
                for _k, _v in obj["calculationProperties"].items()
            )
            if obj.get("calculationProperties") is not None
            else None,
            "relations": dict(
                (_k, BlueprintRelation.from_dict(_v))
                for _k, _v in obj["relations"].items()
            )
            if obj.get("relations") is not None
            else None,
            "options": BlueprintOptions.from_dict(obj["options"]) if obj.get("options") is not None else None,
            "isActive": obj.get("isActive") if obj.get("isActive") is not None else True,
            "isHideable": obj.get("isHideable") if obj.get("isHideable") is not None else True,
            "createdAt": obj.get("createdAt"),
            "createdBy": obj.get("createdBy"),
            "updatedAt": obj.get("updatedAt"),
            "updatedBy": obj.get("updatedBy"),
            "userEditable": obj.get("userEditable"),
            "userDeletable": obj.get("userDeletable")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


